#version 330 core

layout(location = 0) in vec4 inpos;

out VertexData
{
  vec2 texCoord;
} outData;

uniform sampler2D pos;
uniform sampler2D data;

uniform mat4 mat;

void main() {
    int index = int(inpos.z);
    ivec2 disp = ivec2(index / 2, index % 2);
    ivec2 coord = ivec2(inpos.xy);
    ivec2 p1 = ivec2(0, 0);
    ivec2 p2 = ivec2(0, 1);
    ivec2 p3 = ivec2(1, 0);
    ivec2 p4 = ivec2(1, 1);
    vec4 d1 = texelFetch(data, coord + p1, 0);
    vec4 d2 = texelFetch(data, coord + p2, 0);
    vec4 d3 = texelFetch(data, coord + p3, 0);
    vec4 d4 = texelFetch(data, coord + p4, 0);

    gl_Position.xy = vec2(0);
    if (d1.x != 0){
        if (d2.x != 0){
            if (d3.x != 0){
                if (d4.x != 0){
                     gl_Position.xy = (mat * vec4(texelFetch(pos,(coord = coord + disp), 0).xy, 0, 1) ).xy;
                }else{
                    if (disp == p4)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p2), 0).xy, 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
            else{
                if (d4.x != 0){
                    if (disp == p3)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p1), 0).xy, 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }else{

                }
            }
        }else{
            if (d3.x != 0){
                if (d4.x != 0){
                    if (disp == p2)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p4), 0).xy, 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }else{
                    if (disp == p2)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p1), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else if (disp == p4)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p3), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
            else{
                if (d4.x != 0){
                    if (disp == p2)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p1), 0).xy + vec2(0.1, -0.1), 0, 1) ).xy;
                    else if (disp == p3)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p4), 0).xy + vec2(-0.1, 0.1), 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
        }
    }else{
        if (d2.x != 0){
            if (d3.x != 0){
                if (d4.x != 0){
                    if (disp == p1)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p3), 0).xy, 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }else{
                    if (disp == p1)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p2), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else if (disp == p4)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p3), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
            else{
                if (d4.x != 0){
                    if (disp == p1)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p2), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else if (disp == p3)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p4), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
        }else{
            if (d3.x != 0){
                if (d4.x != 0){
                    if (disp == p1)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p3), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else if (disp == p2)
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + p4), 0).xy + vec2(0.1), 0, 1) ).xy;
                    else
                        gl_Position.xy = (mat * vec4(texelFetch(pos, (coord = coord + disp), 0).xy, 0, 1) ).xy;
                }
            }
        }
    }
	outData.texCoord.xy = vec2(coord);
}