#version 330 core

uniform mat4 mat;
uniform ivec2 res;
uniform float time;
uniform float wh = 9;
uniform float ww = 6;

layout(location = 0) out vec4 outcol;



#define LIGHTDEPTH  1000.

float getSea(vec2 pos)
{
    float x = pos.x / ww;
    float y = (sin(x * 0.1f + time) * 0.5f + sin(x * 0.3f - time * 1.1f) * 0.3f) * wh;
    return ((y - pos.y) / LIGHTDEPTH);
}

void main() {
	vec4 col = vec4(0, 0.25, 1, 0.5);
	vec2 uv = (gl_FragCoord.xy / vec2(res.xy) - 0.5) * 2 ;
	mat4 trans = inverse(mat);
	vec4 pos = vec4(uv.xy, 0, 1) * trans;
	float sea = 1 - 1 / ( 1 + getSea(pos.xy));
	if (sea <= 0)
	    discard;
	col = mix(col, vec4(0, 0, 0, 1), clamp(pow(sea, 0.7), 0, 1));
	outcol = col;
	if (col.xyz == vec3(0) && pos.y > 0){
	    discard;
	}
}